<template>
  <!-- BLOCKLY -->
  <!-- BLOCKLY BASADO EN RESPONDER A EVENTOS -->
  <!-- <BlocklyComponent id="blocklyMain" -->
  <!-- :options="options" :parentWorkspace="workspace" @add="loadBlocklyWorkspace" -->
  <!-- ref="blocklyMain"> -->

  <!-- BLOCKLY FUNCIONAL -->
  <BlocklyComponent id="blocklyMain" :options="options"
  @loadRefWorkspaceBlockly="loadRefWorkspaceBlockly" ref="blocklyMain"> </BlocklyComponent>
  <!-- <FloatMenuComponent id="floatMenu"></FloatMenuComponent> -->
  <!-- </BlocklyComponent> -->

  <!-- MENU -->
  <!-- MENU BASADO REQUIERE SER TERMINADO -->
  <!-- <MenuComponent id="menu" :parentWorkspace="workspaceRef"></MenuComponent> -->
  <!-- MENU PRINCIPAL, ESTÁ EN LA BARRA DE TAREAS -->
  <FocusMenu id="mainMenu" :parentWorkspace="workspaceRef"></FocusMenu>

  <!-- FLOAT MENU -->
  <!-- Menu de opciones y acceso a otras funciones -->
  <FloatingCircularMenu id="menu2" :parentWorkspace="workspaceRef"
  @parentSendpreviewCode2Modal="sendpreviewCode2Modal"></FloatingCircularMenu>
  <!-- POPUP -->
  <!-- <SimplePopup id="popup1"></SimplePopup> -->

  <!-- MODAL POPUP -->
  <!-- <div id="modals"></div> -->
  <PreviewCodeModal
  :parentMessage="previewCode2Modal"
  :trigger="triggerPreviewCodeModal"
  ></PreviewCodeModal>
</template>

<script lang="ts">
/**
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * @fileoverview Main Vue component that includes the Blockly component.
 * @author Johnny Cubides <jgcubidesc@gmail.com>
 */

// import { Component, Vue } from 'vue-property-decorator'
import { defineComponent, ref, onMounted } from 'vue'
import BlocklyComponent from './components/BlocklyComponent.vue'
// import MenuComponent from './components/MenuComponent.vue'
// import FloatMenuComponent from './components/FloatMenuComponent.vue'
import FloatingCircularMenu from './components/FloatingCircularMenu.vue'
import FocusMenu from './components/FocusMenu.vue'
import PreviewCodeModal from './components/modals/PreviewCodeModal.vue'
import { toolbox } from './blockly-config/luabot/toolbox'

import Blockly from 'blockly'
import './blockly-config/luabot/luabot'

// import './blocks/stocks'
// import './prompt'

const App = defineComponent({
  name: 'app',
  components: {
    BlocklyComponent,
    // MenuComponent,
    // FloatMenuComponent,
    FloatingCircularMenu,
    FocusMenu,
    PreviewCodeModal
  },
  // tslint:disable-next-line
  setup (_, context) { // eslint-disable-line
    const code = ref(null)
    const workspaceRef = ref(new Blockly.Workspace())
    const options = ref({})
    const previewCode2Modal = ref('')
    const triggerPreviewCodeModal = ref(false)

    options.value =
      {
        media: 'media/',
        theme: 'dark', // dark, classic, highcontrast, deuteranopia, tritanopia
        renderer: 'geras', // geras, thrasos, zelos
        toolboxPosition: 'start', // toolboxPosition-horizontalLayout top: start-true, bottom:end-true, left:start-false, right:end-false
        horizontalLayout: true,
        zoom:
        {
          controls: true,
          wheel: true,
          startScale: 1.0,
          maxScale: 3,
          minScale: 0.3,
          scaleSpeed: 1.2,
          pinch: true
        },
        trashcan: true,
        grid:
          {
            spacing: 25,
            length: 1,
            colour: '#ccc',
            snap: true
          },
        toolbox: toolbox
      }

    // Esta referencia construye el workspace que será usado en
    // los componentes hijos de la aplicación
    // Emit for child
    const loadRefWorkspaceBlockly = (workspaceToRef) => {
      workspaceRef.value = workspaceToRef
    }

    // Emit for child
    const sendpreviewCode2Modal = (message) => {
      previewCode2Modal.value = message
      triggerPreviewCodeModal.value = !triggerPreviewCodeModal.value // trigger the modal
    }

    return {
      // blockly vars start
      code,
      workspaceRef, // general ref of blockly workspace
      options, // options blockly
      // blockly vars end
      previewCode2Modal, // msg to modal
      // triggers modals
      triggerPreviewCodeModal,
      // methods for emits
      loadRefWorkspaceBlockly,
      sendpreviewCode2Modal
    }
  }
})

export default App
</script>

<style>
#app {
  font-family: 'Avenir', Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  color: #2c3e50;
}

html, body {
  margin: 0;
}

/*
#code {
  position: absolute;
  right: 0;
  bottom: 0;
  width: 40%;
  height: 50%;
  margin: 0;
  background-color: beige;
}
*/
/*
#blockly1 {
  position: absolute;
  right: 0;
  top: 0;
  width: 50%;
  height: 50%;
}*/

#blocklyMain {
  top: 60px; /* 72px */
  position: absolute;
  left: 0;
  bottom: 0;
  width: 100%;
  /*height: 90%;*/
}

#mainMenu {
  position: absolute;
  top: 0px;
  height: 60px; /* 72px */
  width: 100%;
}

#modals {
}
</style>
